*** /tmp/extdiff.POztPz/gmp-main.ebc3597af052/mpn/generic/mul_fft.c	Mon Sep 23 20:56:37 2013
--- /home/tege/prec/gmp-main/mpn/generic/mul_fft.c	Mon Sep 23 20:53:07 2013
***************
*** 68,73 ****
  				       mp_ptr *, mp_ptr, mp_ptr, mp_size_t,
  				       mp_size_t, mp_size_t, int **, mp_ptr, int);
! static void mpn_mul_fft_decompose (mp_ptr, mp_ptr *, int, int, mp_srcptr,
! 				   mp_size_t, int, int, mp_ptr);
  
  
--- 68,73 ----
  				       mp_ptr *, mp_ptr, mp_ptr, mp_size_t,
  				       mp_size_t, mp_size_t, int **, mp_ptr, int);
! static void mpn_mul_fft_decompose (mp_ptr, mp_ptr *, int, mp_size_t, mp_srcptr,
! 				   mp_size_t, mp_size_t, mp_size_t, mp_ptr);
  
  
***************
*** 193,228 ****
  */
  static void
! mpn_fft_mul_2exp_modF (mp_ptr r, mp_srcptr a, unsigned int d, mp_size_t n)
  {
    int sh;
    mp_limb_t cc, rd;
  
    sh = d % GMP_NUMB_BITS;
!   d /= GMP_NUMB_BITS;
  
!   if (d >= n)			/* negate */
      {
!       /* r[0..d-1]  <-- lshift(a[n-d]..a[n-1], sh)
! 	 r[d..n-1]  <-- -lshift(a[0]..a[n-d-1],  sh) */
  
!       d -= n;
        if (sh != 0)
  	{
  	  /* no out shift below since a[n] <= 1 */
! 	  mpn_lshift (r, a + n - d, d + 1, sh);
! 	  rd = r[d];
! 	  cc = mpn_lshiftc (r + d, a, n - d, sh);
  	}
        else
  	{
! 	  MPN_COPY (r, a + n - d, d);
  	  rd = a[n];
! 	  mpn_com (r + d, a, n - d);
  	  cc = 0;
  	}
  
!       /* add cc to r[0], and add rd to r[d] */
  
!       /* now add 1 in r[d], subtract 1 in r[n], i.e. add 1 in r[0] */
  
        r[n] = 0;
--- 193,229 ----
  */
  static void
! mpn_fft_mul_2exp_modF (mp_ptr r, mp_srcptr a, mp_bitcnt_t d, mp_size_t n)
  {
    int sh;
+   mp_size_t m;
    mp_limb_t cc, rd;
  
    sh = d % GMP_NUMB_BITS;
!   m = d / GMP_NUMB_BITS;
  
!   if (m >= n)			/* negate */
      {
!       /* r[0..m-1]  <-- lshift(a[n-m]..a[n-1], sh)
! 	 r[m..n-1]  <-- -lshift(a[0]..a[n-m-1],  sh) */
  
!       m -= n;
        if (sh != 0)
  	{
  	  /* no out shift below since a[n] <= 1 */
! 	  mpn_lshift (r, a + n - m, m + 1, sh);
! 	  rd = r[m];
! 	  cc = mpn_lshiftc (r + m, a, n - m, sh);
  	}
        else
  	{
! 	  MPN_COPY (r, a + n - m, m);
  	  rd = a[n];
! 	  mpn_com (r + m, a, n - m);
  	  cc = 0;
  	}
  
!       /* add cc to r[0], and add rd to r[m] */
  
!       /* now add 1 in r[m], subtract 1 in r[n], i.e. add 1 in r[0] */
  
        r[n] = 0;
***************
*** 234,277 ****
        /* rd might overflow when sh=GMP_NUMB_BITS-1 */
        cc = (rd == 0) ? 1 : rd;
!       r = r + d + (rd == 0);
        mpn_incr_u (r, cc);
      }
    else
      {
!       /* r[0..d-1]  <-- -lshift(a[n-d]..a[n-1], sh)
! 	 r[d..n-1]  <-- lshift(a[0]..a[n-d-1],  sh)  */
        if (sh != 0)
  	{
  	  /* no out bits below since a[n] <= 1 */
! 	  mpn_lshiftc (r, a + n - d, d + 1, sh);
! 	  rd = ~r[d];
! 	  /* {r, d+1} = {a+n-d, d+1} << sh */
! 	  cc = mpn_lshift (r + d, a, n - d, sh); /* {r+d, n-d} = {a, n-d}<<sh */
  	}
        else
  	{
! 	  /* r[d] is not used below, but we save a test for d=0 */
! 	  mpn_com (r, a + n - d, d + 1);
  	  rd = a[n];
! 	  MPN_COPY (r + d, a, n - d);
  	  cc = 0;
  	}
  
!       /* now complement {r, d}, subtract cc from r[0], subtract rd from r[d] */
  
!       /* if d=0 we just have r[0]=a[n] << sh */
!       if (d != 0)
  	{
! 	  /* now add 1 in r[0], subtract 1 in r[d] */
  	  if (cc-- == 0) /* then add 1 to r[0] */
  	    cc = mpn_add_1 (r, r, n, CNST_LIMB(1));
! 	  cc = mpn_sub_1 (r, r, d, cc) + 1;
  	  /* add 1 to cc instead of rd since rd might overflow */
  	}
  
!       /* now subtract cc and rd from r[d..n] */
  
!       r[n] = -mpn_sub_1 (r + d, r + d, n - d, cc);
!       r[n] -= mpn_sub_1 (r + d, r + d, n - d, rd);
        if (r[n] & GMP_LIMB_HIGHBIT)
  	r[n] = mpn_add_1 (r, r, n, CNST_LIMB(1));
--- 235,278 ----
        /* rd might overflow when sh=GMP_NUMB_BITS-1 */
        cc = (rd == 0) ? 1 : rd;
!       r = r + m + (rd == 0);
        mpn_incr_u (r, cc);
      }
    else
      {
!       /* r[0..m-1]  <-- -lshift(a[n-m]..a[n-1], sh)
! 	 r[m..n-1]  <-- lshift(a[0]..a[n-m-1],  sh)  */
        if (sh != 0)
  	{
  	  /* no out bits below since a[n] <= 1 */
! 	  mpn_lshiftc (r, a + n - m, m + 1, sh);
! 	  rd = ~r[m];
! 	  /* {r, m+1} = {a+n-m, m+1} << sh */
! 	  cc = mpn_lshift (r + m, a, n - m, sh); /* {r+m, n-m} = {a, n-m}<<sh */
  	}
        else
  	{
! 	  /* r[m] is not used below, but we save a test for m=0 */
! 	  mpn_com (r, a + n - m, m + 1);
  	  rd = a[n];
! 	  MPN_COPY (r + m, a, n - m);
  	  cc = 0;
  	}
  
!       /* now complement {r, m}, subtract cc from r[0], subtract rd from r[m] */
  
!       /* if m=0 we just have r[0]=a[n] << sh */
!       if (m != 0)
  	{
! 	  /* now add 1 in r[0], subtract 1 in r[m] */
  	  if (cc-- == 0) /* then add 1 to r[0] */
  	    cc = mpn_add_1 (r, r, n, CNST_LIMB(1));
! 	  cc = mpn_sub_1 (r, r, m, cc) + 1;
  	  /* add 1 to cc instead of rd since rd might overflow */
  	}
  
!       /* now subtract cc and rd from r[m..n] */
  
!       r[n] = -mpn_sub_1 (r + m, r + m, n - m, cc);
!       r[n] -= mpn_sub_1 (r + m, r + m, n - m, rd);
        if (r[n] & GMP_LIMB_HIGHBIT)
  	r[n] = mpn_add_1 (r, r, n, CNST_LIMB(1));
***************
*** 284,288 ****
  */
  static inline void
! mpn_fft_add_modF (mp_ptr r, mp_srcptr a, mp_srcptr b, int n)
  {
    mp_limb_t c, x;
--- 285,289 ----
  */
  static inline void
! mpn_fft_add_modF (mp_ptr r, mp_srcptr a, mp_srcptr b, mp_size_t n)
  {
    mp_limb_t c, x;
***************
*** 315,319 ****
  */
  static inline void
! mpn_fft_sub_modF (mp_ptr r, mp_srcptr a, mp_srcptr b, int n)
  {
    mp_limb_t c, x;
--- 316,320 ----
  */
  static inline void
! mpn_fft_sub_modF (mp_ptr r, mp_srcptr a, mp_srcptr b, mp_size_t n)
  {
    mp_limb_t c, x;
***************
*** 429,438 ****
    if (n >= (sqr ? SQR_FFT_MODF_THRESHOLD : MUL_FFT_MODF_THRESHOLD))
      {
!       int k, K2, nprime2, Nprime2, M2, maxLK, l, Mp2;
        int **fft_l, *tmp;
        mp_ptr *Ap, *Bp, A, B, T;
  
        k = mpn_fft_best_k (n, sqr);
!       K2 = 1 << k;
        ASSERT_ALWAYS((n & (K2 - 1)) == 0);
        maxLK = (K2 > GMP_NUMB_BITS) ? K2 : GMP_NUMB_BITS;
--- 430,440 ----
    if (n >= (sqr ? SQR_FFT_MODF_THRESHOLD : MUL_FFT_MODF_THRESHOLD))
      {
!       mp_size_t K2, nprime2, Nprime2, M2, maxLK, l, Mp2;
!       int k;
        int **fft_l, *tmp;
        mp_ptr *Ap, *Bp, A, B, T;
  
        k = mpn_fft_best_k (n, sqr);
!       K2 = (mp_size_t) 1 << k;
        ASSERT_ALWAYS((n & (K2 - 1)) == 0);
        maxLK = (K2 > GMP_NUMB_BITS) ? K2 : GMP_NUMB_BITS;
***************
*** 446,453 ****
        if (nprime2 >= (sqr ? SQR_FFT_MODF_THRESHOLD : MUL_FFT_MODF_THRESHOLD))
  	{
! 	  unsigned long K3;
  	  for (;;)
  	    {
! 	      K3 = 1L << mpn_fft_best_k (nprime2, sqr);
  	      if ((nprime2 & (K3 - 1)) == 0)
  		break;
--- 448,455 ----
        if (nprime2 >= (sqr ? SQR_FFT_MODF_THRESHOLD : MUL_FFT_MODF_THRESHOLD))
  	{
! 	  mp_size_t K3;
  	  for (;;)
  	    {
! 	      K3 = (mp_size_t) 1 << mpn_fft_best_k (nprime2, sqr);
  	      if ((nprime2 & (K3 - 1)) == 0)
  		break;
***************
*** 471,480 ****
  	{
  	  fft_l[i] = tmp;
! 	  tmp += 1 << i;
  	}
  
        mpn_fft_initl (fft_l, k);
  
!       TRACE (printf ("recurse: %ldx%ld limbs -> %d times %dx%d (%1.2f)\n", n,
  		    n, K2, nprime2, nprime2, 2.0*(double)n/nprime2/K2));
        for (i = 0; i < K; i++, ap++, bp++)
--- 473,482 ----
  	{
  	  fft_l[i] = tmp;
! 	  tmp += (mp_size_t) 1 << i;
  	}
  
        mpn_fft_initl (fft_l, k);
  
!       TRACE (printf ("recurse: %ldx%ld limbs -> %ld times %ldx%ld (%1.2f)\n", n,
  		    n, K2, nprime2, nprime2, 2.0*(double)n/nprime2/K2));
        for (i = 0; i < K; i++, ap++, bp++)
***************
*** 498,502 ****
        mp_ptr a, b, tp, tpn;
        mp_limb_t cc;
!       int n2 = 2 * n;
        tp = TMP_BALLOC_LIMBS (n2);
        tpn = tp + n;
--- 500,504 ----
        mp_ptr a, b, tp, tpn;
        mp_limb_t cc;
!       mp_size_t n2 = 2 * n;
        tp = TMP_BALLOC_LIMBS (n2);
        tpn = tp + n;
***************
*** 574,583 ****
  /* R <- A/2^k mod 2^(n*GMP_NUMB_BITS)+1 */
  static void
! mpn_fft_div_2exp_modF (mp_ptr r, mp_srcptr a, int k, mp_size_t n)
  {
!   int i;
  
    ASSERT (r != a);
!   i = 2 * n * GMP_NUMB_BITS - k;
    mpn_fft_mul_2exp_modF (r, a, i, n);
    /* 1/2^k = 2^(2nL-k) mod 2^(n*GMP_NUMB_BITS)+1 */
--- 576,585 ----
  /* R <- A/2^k mod 2^(n*GMP_NUMB_BITS)+1 */
  static void
! mpn_fft_div_2exp_modF (mp_ptr r, mp_srcptr a, mp_bitcnt_t k, mp_size_t n)
  {
!   mp_bitcnt_t i;
  
    ASSERT (r != a);
!   i = (mp_bitcnt_t) 2 * n * GMP_NUMB_BITS - k;
    mpn_fft_mul_2exp_modF (r, a, i, n);
    /* 1/2^k = 2^(2nL-k) mod 2^(n*GMP_NUMB_BITS)+1 */
***************
*** 594,599 ****
  mpn_fft_norm_modF (mp_ptr rp, mp_size_t n, mp_ptr ap, mp_size_t an)
  {
!   mp_size_t l;
!   long int m;
    mp_limb_t cc;
    int rpn;
--- 596,600 ----
  mpn_fft_norm_modF (mp_ptr rp, mp_size_t n, mp_ptr ap, mp_size_t an)
  {
!   mp_size_t l, m;
    mp_limb_t cc;
    int rpn;
***************
*** 631,638 ****
  */
  static void
! mpn_mul_fft_decompose (mp_ptr A, mp_ptr *Ap, int K, int nprime, mp_srcptr n,
! 		       mp_size_t nl, int l, int Mp, mp_ptr T)
  {
!   int i, j;
    mp_ptr tmp;
    mp_size_t Kl = K * l;
--- 632,640 ----
  */
  static void
! mpn_mul_fft_decompose (mp_ptr A, mp_ptr *Ap, int K, mp_size_t nprime,
! 		       mp_srcptr n, mp_size_t nl, mp_size_t l, mp_size_t Mp,
! 		       mp_ptr T)
  {
!   mp_size_t i, j;
    mp_ptr tmp;
    mp_size_t Kl = K * l;
***************
*** 718,726 ****
  		      int **fft_l, mp_ptr T, int sqr)
  {
!   int K, i, pla, lo, sh, j;
    mp_ptr p;
    mp_limb_t cc;
  
!   K = 1 << k;
  
    /* direct fft's */
--- 720,728 ----
  		      int **fft_l, mp_ptr T, int sqr)
  {
!   mp_size_t K, i, pla, lo, sh, j;
    mp_ptr p;
    mp_limb_t cc;
  
!   K = (mp_size_t) 1 << k;
  
    /* direct fft's */
***************
*** 798,805 ****
  
  /* return the lcm of a and 2^k */
! static unsigned long int
! mpn_mul_fft_lcm (unsigned long int a, unsigned int k)
  {
!   unsigned long int l = k;
  
    while (a % 2 == 0 && k > 0)
--- 800,807 ----
  
  /* return the lcm of a and 2^k */
! static mp_bitcnt_t
! mpn_mul_fft_lcm (mp_bitcnt_t a, int k)
  {
!   mp_bitcnt_t l = k;
  
    while (a % 2 == 0 && k > 0)
***************
*** 818,822 ****
  	     int k)
  {
!   int K, maxLK, i;
    mp_size_t N, Nprime, nprime, M, Mp, l;
    mp_ptr *Ap, *Bp, A, T, B;
--- 820,825 ----
  	     int k)
  {
!   int i;
!   mp_size_t K, maxLK;
    mp_size_t N, Nprime, nprime, M, Mp, l;
    mp_ptr *Ap, *Bp, A, T, B;
***************
*** 836,860 ****
      {
        fft_l[i] = tmp;
!       tmp += 1 << i;
      }
  
    mpn_fft_initl (fft_l, k);
!   K = 1 << k;
    M = N >> k;	/* N = 2^k M */
    l = 1 + (M - 1) / GMP_NUMB_BITS;
!   maxLK = mpn_mul_fft_lcm ((unsigned long) GMP_NUMB_BITS, k); /* lcm (GMP_NUMB_BITS, 2^k) */
  
    Nprime = (1 + (2 * M + k + 2) / maxLK) * maxLK;
    /* Nprime = ceil((2*M+k+3)/maxLK)*maxLK; */
    nprime = Nprime / GMP_NUMB_BITS;
!   TRACE (printf ("N=%ld K=%d, M=%ld, l=%ld, maxLK=%d, Np=%ld, np=%ld\n",
  		 N, K, M, l, maxLK, Nprime, nprime));
    /* we should ensure that recursively, nprime is a multiple of the next K */
    if (nprime >= (sqr ? SQR_FFT_MODF_THRESHOLD : MUL_FFT_MODF_THRESHOLD))
      {
!       unsigned long K2;
        for (;;)
  	{
! 	  K2 = 1L << mpn_fft_best_k (nprime, sqr);
  	  if ((nprime & (K2 - 1)) == 0)
  	    break;
--- 839,863 ----
      {
        fft_l[i] = tmp;
!       tmp += (mp_size_t) 1 << i;
      }
  
    mpn_fft_initl (fft_l, k);
!   K = (mp_size_t) 1 << k;
    M = N >> k;	/* N = 2^k M */
    l = 1 + (M - 1) / GMP_NUMB_BITS;
!   maxLK = mpn_mul_fft_lcm (GMP_NUMB_BITS, k); /* lcm (GMP_NUMB_BITS, 2^k) */
  
    Nprime = (1 + (2 * M + k + 2) / maxLK) * maxLK;
    /* Nprime = ceil((2*M+k+3)/maxLK)*maxLK; */
    nprime = Nprime / GMP_NUMB_BITS;
!   TRACE (printf ("N=%ld K=%ld, M=%ld, l=%ld, maxLK=%ld, Np=%ld, np=%ld\n",
  		 N, K, M, l, maxLK, Nprime, nprime));
    /* we should ensure that recursively, nprime is a multiple of the next K */
    if (nprime >= (sqr ? SQR_FFT_MODF_THRESHOLD : MUL_FFT_MODF_THRESHOLD))
      {
!       mp_size_t K2;
        for (;;)
  	{
! 	  K2 = (mp_size_t) 1 << mpn_fft_best_k (nprime, sqr);
  	  if ((nprime & (K2 - 1)) == 0)
  	    break;
***************
*** 863,867 ****
  	  /* warning: since nprime changed, K2 may change too! */
  	}
!       TRACE (printf ("new maxLK=%d, Np=%ld, np=%ld\n", maxLK, Nprime, nprime));
      }
    ASSERT_ALWAYS (nprime < pl); /* otherwise we'll loop */
--- 866,870 ----
  	  /* warning: since nprime changed, K2 may change too! */
  	}
!       TRACE (printf ("new maxLK=%ld, Np=%ld, np=%ld\n", maxLK, Nprime, nprime));
      }
    ASSERT_ALWAYS (nprime < pl); /* otherwise we'll loop */
***************
*** 870,874 ****
    Mp = Nprime >> k;
  
!   TRACE (printf ("%ldx%ld limbs -> %d times %ldx%ld limbs (%1.2f)\n",
  		pl, pl, K, nprime, nprime, 2.0 * (double) N / Nprime / K);
  	 printf ("   temp space %ld\n", 2 * K * (nprime + 1)));
--- 873,877 ----
    Mp = Nprime >> k;
  
!   TRACE (printf ("%ldx%ld limbs -> %ld times %ldx%ld limbs (%1.2f)\n",
  		pl, pl, K, nprime, nprime, 2.0 * (double) N / Nprime / K);
  	 printf ("   temp space %ld\n", 2 * K * (nprime + 1)));